"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const path_1 = require("path");
const components_1 = require("typedoc/dist/lib/converter/components");
const converter_1 = require("typedoc/dist/lib/converter");
const basePathsToIgnore = ["model"];
let SdkClientSourceUpdatePlugin = class SdkClientSourceUpdatePlugin extends components_1.ConverterComponent {
    initialize() {
        this.listenTo(this.owner, {
            [converter_1.Converter.EVENT_BEGIN]: this.onBegin
        });
    }
    /**
     * Purge source files we wish to ignore.
     * @param context
     */
    onBegin(context) {
        const program = context.program;
        const basePath = program.getCommonSourceDirectory();
        const sourceFiles = program.getSourceFiles();
        for (let i = sourceFiles.length - 1; i >= 0; i--) {
            const sourceFile = sourceFiles[i];
            if (sourceFile.fileName.indexOf(basePath) !== 0) {
                continue;
            }
            let localPath = sourceFile.fileName.substring(basePath.length);
            localPath = localPath.split(path_1.sep)[0];
            if (!basePathsToIgnore.every(basePath => basePath !== localPath)) {
                // the file should be ignored, so remove it
                sourceFiles.splice(i, 1);
            }
        }
    }
};
SdkClientSourceUpdatePlugin = tslib_1.__decorate([
    components_1.Component({ name: "SdkClientSourceUpdatePlugin" })
], SdkClientSourceUpdatePlugin);
exports.SdkClientSourceUpdatePlugin = SdkClientSourceUpdatePlugin;
//# sourceMappingURL=sdk-client-source-update.js.map